#include <stdio.h>
#include <stdlib.h>

#if !defined(INIT_VALUE)
#error("Please compile with the option -DINIT_VALUE=n");
#endif

#define MAX_LINE 64

// versione non rientrante
int somma(int x) {
    static int s = INIT_VALUE;
    s +=x;
    return s;
}

// versione rientrante
int somma_r(int x, int *s) {
    *s += x;
    return *s;
}

int main(int argc, char *argv[]) {
    if (argc != 2) {
	fprintf(stderr, "usa: %s file\n", argv[0]);
	return -1;
    }
    FILE *fp = fopen(argv[1], "r");
    if (!fp) {
	perror("fopen");
	return -1;
    }
    int s = INIT_VALUE;  // variabile locale per la versione rientrante (somma_r)
    char line[MAX_LINE];
    while(fgets(line, MAX_LINE, fp) != NULL) {

	// un po' pericoloso perche' non si controlla che line
	// contenga effettivamente un intero
	int val = strtol(line, NULL,0); 

#if 0
    // in alternativa con inserimento da tastiera -- il while si sostituisce con
    for(;;) { 	// si va avanti finche val non e' negativo.
	int val;
	fprintf(stdout, "Inserisci un numero (<0 per terminare): ");
	if (fscanf(stdin, "%d", &val) != 1) {
	    perror("fscanf");
	    return EXIT_FAILURE;
	}
	
	if (val == -1) break;
#endif

	fprintf(stdout, "somma   %d\n", somma(val));     
	fprintf(stdout, "somma_r %d\n", somma_r(val, &s));
    }

    //if (fp) fclose(fp);

    return 0;       
}
